Imports System.IO
Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private m_XMLFile As String

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Name = "Form1"
        Me.Text = "FormProperties"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadParameters()
    End Sub

    ' Load the parameters saved in the XML file.
    Private Sub LoadParameters()
        Dim xml_doc As XmlDocument
        Dim settings_root As XmlNode
        Dim setting_value As XmlNode
        Dim X As Integer
        Dim Y As Integer
        Dim wid As Integer
        Dim hgt As Integer

        ' Find the XML file holding our settings.
        m_XMLFile = DataSubdirectory() & "\Settings.xml"

        ' Do nothing if the setting file doesn't exist.
        If Dir(m_XMLFile).Length = 0 Then Exit Sub

        ' Load the XML file.
        xml_doc = New XmlDocument()
        Try
            xml_doc.Load(m_XMLFile)
        Catch exc_other As Exception
            ' Tell the user about the error.
            MsgBox("Error opening file " & m_XMLFile & _
                    vbCrLf & exc_other.Message, _
                MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, _
                "Error")
            Exit Sub
        End Try

        ' Get the root of the settings subtree.
        settings_root = xml_doc.DocumentElement()

        ' Read the saved settings.
        X = GetChildInteger(settings_root, "x", Me.Location.X)
        Y = GetChildInteger(settings_root, "y", Me.Location.Y)
        wid = GetChildInteger(settings_root, "width", Me.Size.Width)
        hgt = GetChildInteger(settings_root, "height", Me.Size.Height)

        ' Apply the settings.
        Me.SetBounds(X, Y, wid, hgt)
    End Sub

    ' Save the parameters into the XML file.
    Private Sub SaveParameters()
        Dim xml_doc As New XmlDocument()
        Dim settings_root As XmlNode
        Dim setting_value As XmlNode
        Dim X As Integer
        Dim Y As Integer
        Dim wid As Integer
        Dim hgt As Integer

        ' Make the declaration.
        xml_doc.AppendChild(xml_doc.CreateXmlDeclaration("1.0", Nothing, Nothing))

        ' Create the settings root node.
        settings_root = xml_doc.CreateElement("settings")
        xml_doc.AppendChild(settings_root)

        ' Create the setting value nodes.
        SaveXmlValue(xml_doc, settings_root, "x", Me.Location.X.ToString)
        SaveXmlValue(xml_doc, settings_root, "y", Me.Location.Y.ToString)
        SaveXmlValue(xml_doc, settings_root, "width", Me.Size.Width.ToString)
        SaveXmlValue(xml_doc, settings_root, "height", Me.Size.Height.ToString)

        ' Save the XML document into the file.
        Try
            xml_doc.Save(m_XMLFile)
        Catch exc_other As Exception
            ' Tell the user what went wrong.
            MsgBox("Error writing file " & _
                    m_XMLFile & vbCrLf & _
                    exc_other.Message, _
                MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, _
                "Error")
            Exit Sub
        End Try
    End Sub

    ' Find the child node with the given name and 
    ' return its InnerText converted into an integer.
    ' If the child node doesn't exist or InnerText is
    ' not an integer, return the default value.
    Private Function GetChildInteger(ByVal parent_node As XmlNode, ByVal child_name As String, Optional ByVal default_value As Integer = 0) As Integer
        Dim child_node As XmlNode

        Try
            ' Get the child node.
            child_node = parent_node.Item(child_name)
        Catch
            ' Cannot find the child. Return the default.
            Return default_value
        End Try

        ' Return the child's InnerText.
        Try
            ' Convert InnerText into an integer.
            Return CInt(child_node.InnerText)
        Catch
            ' InnerText is not an integer. Return the default.
            Return default_value
        End Try
    End Function

    Private Sub SaveXmlValue(ByVal xml_doc As XmlDocument, ByVal parent_node As XmlNode, ByVal child_name As String, ByVal inner_text As String)
        Dim child_node As XmlNode

        child_node = xml_doc.CreateElement(child_name)
        child_node.InnerText = inner_text
        parent_node.AppendChild(child_node)
    End Sub

    ' Save the current settings.
    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        SaveParameters()
    End Sub
End Class
