Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents txtFile As System.Windows.Forms.TextBox
                                Friend WithEvents lblFile As System.Windows.Forms.Label
    Friend WithEvents btnSelectNodes As System.Windows.Forms.Button
    Friend WithEvents txtResults As System.Windows.Forms.TextBox
    Friend WithEvents btnSelectSingleNode As System.Windows.Forms.Button
        
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtResults = New System.Windows.Forms.TextBox()
        Me.lblFile = New System.Windows.Forms.Label()
        Me.txtFile = New System.Windows.Forms.TextBox()
        Me.btnSelectSingleNode = New System.Windows.Forms.Button()
        Me.btnSelectNodes = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'txtResults
        '
        Me.txtResults.Location = New System.Drawing.Point(232, 24)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtResults.Size = New System.Drawing.Size(200, 304)
        Me.txtResults.TabIndex = 2
        Me.txtResults.Text = ""
        '
        'lblFile
        '
        Me.lblFile.Name = "lblFile"
        Me.lblFile.Size = New System.Drawing.Size(224, 16)
        Me.lblFile.TabIndex = 4
        Me.lblFile.Text = "File"
        Me.lblFile.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'txtFile
        '
        Me.txtFile.Location = New System.Drawing.Point(0, 24)
        Me.txtFile.Multiline = True
        Me.txtFile.Name = "txtFile"
        Me.txtFile.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtFile.Size = New System.Drawing.Size(224, 309)
        Me.txtFile.TabIndex = 3
        Me.txtFile.Text = ""
        '
        'btnSelectSingleNode
        '
        Me.btnSelectSingleNode.Location = New System.Drawing.Point(344, 0)
        Me.btnSelectSingleNode.Name = "btnSelectSingleNode"
        Me.btnSelectSingleNode.Size = New System.Drawing.Size(112, 23)
        Me.btnSelectSingleNode.TabIndex = 1
        Me.btnSelectSingleNode.Text = "SelectSingleNode"
        '
        'btnSelectNodes
        '
        Me.btnSelectNodes.Location = New System.Drawing.Point(224, 0)
        Me.btnSelectNodes.Name = "btnSelectNodes"
        Me.btnSelectNodes.Size = New System.Drawing.Size(112, 23)
        Me.btnSelectNodes.TabIndex = 0
        Me.btnSelectNodes.Text = "SelectNodes"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(528, 341)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnSelectSingleNode, Me.txtResults, Me.btnSelectNodes, Me.lblFile, Me.txtFile})
        Me.Name = "Form1"
        Me.Text = "SelectSingleNode"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private xml_document As XmlDocument

    ' Load the XML document.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim file_name As String = DataSubdirectory() & "\ABC.xml"

        ' Display the file.
        txtFile.Text = GetFileContents(file_name)

        ' Load the document.
        xml_document = New XmlDocument()
        xml_document.Load(file_name)
    End Sub

    ' Display the values of the matching elements.
    ' Arrange the controls to fill the form.
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim wid As Integer
        Dim hgt As Integer

        wid = ClientSize.Width \ 2
        hgt = ClientSize.Height - txtFile.Location.Y
        If hgt < 10 Then hgt = 10
        lblFile.SetBounds(0, 0, wid, lblFile.Size.Height)
        txtFile.SetBounds(0, txtFile.Location.Y, wid, hgt)

        btnSelectNodes.SetBounds(wid + 10, 0, btnSelectNodes.Size.Width, btnSelectNodes.Size.Height)
        btnSelectSingleNode.SetBounds(wid + 20 + btnSelectNodes.Size.Width, 0, btnSelectSingleNode.Size.Width, btnSelectSingleNode.Size.Height)

        hgt = ClientSize.Height - txtResults.Location.Y
        If hgt < 10 Then hgt = 10
        txtResults.SetBounds(wid, txtResults.Location.Y, wid, hgt)
    End Sub

    ' Find and list the B nodes using SelectNodes.
    Private Sub btnSelectNodes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectNodes.Click
        Dim xml_node_list As XmlNodeList
        Dim xml_node As XmlNode
        Dim results As String
        Dim start_time As Single
        Dim stop_time As Single

        ' Get a list of the matching nodes.
        start_time = Timer
        Try
            xml_node_list = xml_document.SelectNodes("//B")

            ' Display the elements.
            For Each xml_node In xml_node_list
                results = results & xml_node.Name & " (" & _
                    xml_node.Attributes(0).Value & ")" & vbCrLf
            Next xml_node

        Catch exc As Exception
            MsgBox(exc.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly, "SelectNodes Error")
        End Try
        stop_time = Timer

        txtResults.Text = "Ellapsed time: " & _
            Format(stop_time - start_time, "0.00") & _
            " seconds" & vbCrLf & results
    End Sub

    ' Find and list the B nodes using SelectSingleNode.
    Private Sub btnSelectSingleNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectSingleNode.Click
        Dim xml_node As XmlNode
        Dim results As String
        Dim start_time As Single
        Dim stop_time As Single

        ' Get the first matching node.
        start_time = Timer
        Try
            xml_node = xml_document.SelectSingleNode("//B")

            ' Display the elements.
            Do Until xml_node Is Nothing
                ' Display this element.
                results = results & xml_node.Name & " (" & _
                    xml_node.Attributes(0).Value & ")" & vbCrLf

                ' Move to the next element.
                xml_node = xml_node.NextSibling
            Loop

        Catch exc As Exception
            MsgBox(exc.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly, "SelectSingleNode Error")
        End Try
        stop_time = Timer

        txtResults.Text = "Ellapsed time: " & _
            Format(stop_time - start_time, "0.00") & _
            " seconds" & vbCrLf & results
    End Sub
End Class
